Index: trunk/LMDZ.COMMON/libf/evolution/pem.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/evolution/pem.F90	(revision 3570)
+++ trunk/LMDZ.COMMON/libf/evolution/pem.F90	(revision 3571)
@@ -749,42 +730,38 @@
     if (adsorption_pem) then
         do i = 1,ngrid
-            global_avg_press_new = global_avg_press_new - g*cell_area(i)*delta_co2_adsorbed(i)/Total_surface
-        enddo
-    endif
-    write(*,*) 'Global average pressure old time step',global_avg_press_old
-    write(*,*) 'Global average pressure new time step',global_avg_press_new
-
-! II.a.2. Old pressure levels for the timeseries, this value is deleted when unused and recreated each time (big memory consumption)
-    allocate(zplev_old_timeseries(ngrid,nlayer + 1,timelen))
-    write(*,*) "Recomputing the old pressure levels timeserie adapted to the old pressure..."
+            ps_avg_global_new = ps_avg_global_old - g*cell_area(i)*delta_co2_adsorbed(i)/total_surface
+        enddo
+    endif
+    write(*,*) 'Global average pressure old time step',ps_avg_global_old
+    write(*,*) 'Global average pressure new time step',ps_avg_global_new
+
+! II.a.2. Pressure timeseries (the values are deleted when unused because of big memory consumption)
+    allocate(zplev_timeseries_old(ngrid,nlayer + 1,timelen))
+    write(*,*) "Recomputing the pressure levels timeseries adapted to the old pressure..."
     do l = 1,nlayer + 1
         do ig = 1,ngrid
-            zplev_old_timeseries(ig,l,:) = ap(l) + bp(l)*ps_timeseries(ig,:)
-        enddo
-    enddo
-
-! II.a.3. Surface pressure timeseries
-    write(*,*) "Recomputing the surface pressure timeserie adapted to the new pressure..."
+            zplev_timeseries_old(ig,l,:) = ap(l) + bp(l)*ps_timeseries(ig,:)
+        enddo
+    enddo
+    write(*,*) "Recomputing the surface pressure timeseries adapted to the new pressure..."
     do ig = 1,ngrid
-        ps_timeseries(ig,:) = ps_timeseries(ig,:)*global_avg_press_new/global_avg_press_old
-    enddo
-
-! II.a.4. New pressure levels timeseries
-    allocate(zplev_new_timeseries(ngrid,nlayer + 1,timelen))
-    write(*,*) "Recomputing the new pressure levels timeserie adapted to the new pressure..."
+        ps_timeseries(ig,:) = ps_timeseries(ig,:)*ps_avg_global_new/ps_avg_global_old
+    enddo
+    write(*,*) "Recomputing the pressure levels timeseries adapted to the new pressure..."
+    allocate(zplev_timeseries_new(ngrid,nlayer + 1,timelen))
     do l = 1,nlayer + 1
         do ig = 1,ngrid
-            zplev_new_timeseries(ig,l,:) = ap(l) + bp(l)*ps_timeseries(ig,:)
-        enddo
-    enddo
-
-! II.a.5. Tracers timeseries
+            zplev_timeseries_new(ig,l,:) = ap(l) + bp(l)*ps_timeseries(ig,:)
+        enddo
+    enddo
+
+! II.a.3. Tracers timeseries
     write(*,*) "Recomputing of tracer VMR timeseries for the new pressure..."
-
     l = 1
     do ig = 1,ngrid
         do t = 1,timelen
-            q_h2o_PEM_phys(ig,t) = q_h2o_PEM_phys(ig,t)*(zplev_old_timeseries(ig,l,t) - zplev_old_timeseries(ig,l + 1,t))/ &
-                                   (zplev_new_timeseries(ig,l,t) - zplev_new_timeseries(ig,l + 1,t))
+            ! H2O
+            q_h2o_PEM_phys(ig,t) = q_h2o_PEM_phys(ig,t)*(zplev_timeseries_old(ig,l,t) - zplev_timeseries_old(ig,l + 1,t))/ &
+                                   (zplev_timeseries_new(ig,l,t) - zplev_timeseries_new(ig,l + 1,t))
             if (q_h2o_PEM_phys(ig,t) < 0) then
                 q_h2o_PEM_phys(ig,t) = 1.e-30
@@ -792,14 +769,10 @@
                 q_h2o_PEM_phys(ig,t) = 1.
             endif
-        enddo
-    enddo
-
-    do ig = 1,ngrid
-        do t = 1,timelen
-            q_co2_PEM_phys(ig,t) = q_co2_PEM_phys(ig,t)*(zplev_old_timeseries(ig,l,t) - zplev_old_timeseries(ig,l + 1,t))/ &
-                                   (zplev_new_timeseries(ig,l,t) - zplev_new_timeseries(ig,l + 1,t))                       &
-                                + ((zplev_new_timeseries(ig,l,t) - zplev_new_timeseries(ig,l + 1,t))                       &
-                                -  (zplev_old_timeseries(ig,l,t) - zplev_old_timeseries(ig,l + 1,t)))/                     &
-                                   (zplev_new_timeseries(ig,l,t) - zplev_new_timeseries(ig,l + 1,t))
+            ! CO2
+            q_co2_PEM_phys(ig,t) = q_co2_PEM_phys(ig,t)*(zplev_timeseries_old(ig,l,t) - zplev_timeseries_old(ig,l + 1,t))/ &
+                                   (zplev_timeseries_new(ig,l,t) - zplev_timeseries_new(ig,l + 1,t))                       &
+                                + ((zplev_timeseries_new(ig,l,t) - zplev_timeseries_new(ig,l + 1,t))                       &
+                                -  (zplev_timeseries_old(ig,l,t) - zplev_timeseries_old(ig,l + 1,t)))/                     &
+                                   (zplev_timeseries_new(ig,l,t) - zplev_timeseries_new(ig,l + 1,t))
             if (q_co2_PEM_phys(ig,t) < 0) then
                 q_co2_PEM_phys(ig,t) = 1.e-30
@@ -807,10 +780,9 @@
                 q_co2_PEM_phys(ig,t) = 1.
             endif
-            mmean=1/(A*q_co2_PEM_phys(ig,t) + B)
+            mmean = 1./(A*q_co2_PEM_phys(ig,t) + B)
             vmr_co2_PEM_phys(ig,t) = q_co2_PEM_phys(ig,t)*mmean/m_co2
         enddo
     enddo
-
-    deallocate(zplev_new_timeseries,zplev_old_timeseries)
+    deallocate(zplev_timeseries_new,zplev_timeseries_old)
 
 !------------------------
@@ -834,7 +806,7 @@
 !    II_c Flow of glaciers
 !------------------------
-    if (co2ice_flow .and. nslope > 1) call flow_co2glaciers(timelen,ngrid,nslope,iflat,subslope_dist,def_slope_mean,vmr_co2_PEM_phys,ps_timeseries, &
-                                                            global_avg_press_PCM,global_avg_press_new,co2_ice,flag_co2flow,flag_co2flow_mesh)
-    if (h2oice_flow .and. nslope > 1) call flow_h2oglaciers(timelen,ngrid,nslope,iflat,subslope_dist,def_slope_mean,tsurf_avg,h2o_ice,flag_h2oflow,flag_h2oflow_mesh)
+    if (co2ice_flow .and. nslope > 1) call flow_co2glaciers(timelen,ngrid,nslope,iflat,subslope_dist,def_slope_mean,vmr_co2_PEM_phys, &
+                                                            ps_timeseries,ps_avg_global_old,ps_avg_global_new,co2_ice,flag_co2flow,flag_co2flow_mesh)
+    if (h2oice_flow .and. nslope > 1) call flow_h2oglaciers(ngrid,nslope,iflat,subslope_dist,def_slope_mean,tsurf_avg,h2o_ice,flag_h2oflow,flag_h2oflow_mesh)
 
 !------------------------
@@ -844,34 +816,29 @@
 ! II_d.1 Update Tsurf
     write(*,*) "Updating the new Tsurf"
-    bool_sublim = .false.
-    Tsurfavg_before_saved = tsurf_avg
     do ig = 1,ngrid
         do islope = 1,nslope
-            if (is_co2ice_ini(ig,islope) .and. co2_ice(ig,islope) < 1.e-10 .and. .not. co2ice_disappeared(ig,islope)) then ! co2 ice disappeared, look for closest point without co2ice
+            ! CO2 ice disappeared so we look for the closest point without CO2 ice
+            if (is_co2ice_ini(ig,islope) .and. co2_ice(ig,islope) < 1.e-10 .and. .not. co2ice_disappeared(ig,islope)) then
                 co2ice_disappeared(ig,islope) = .true.
                 if (latitude_deg(ig) > 0) then
-                    do ig_loop = ig,ngrid
+                    outer1: do ig_loop = ig,ngrid
                         do islope_loop = islope,iflat,-1
                             if (.not. is_co2ice_ini(ig_loop,islope_loop) .and. co2_ice(ig_loop,islope_loop) < 1.e-10) then
                                 tsurf_avg(ig,islope) = tsurf_avg(ig_loop,islope_loop)
-                                bool_sublim = .true.
-                                exit
+                                exit outer1
                             endif
                         enddo
-                        if (bool_sublim) exit
-                    enddo
+                    enddo outer1
                 else
-                    do ig_loop = ig,1,-1
+                    outer2: do ig_loop = ig,1,-1
                         do islope_loop = islope,iflat
                             if (.not. is_co2ice_ini(ig_loop,islope_loop) .and. co2_ice(ig_loop,islope_loop) < 1.e-10) then
                                 tsurf_avg(ig,islope) = tsurf_avg(ig_loop,islope_loop)
-                                bool_sublim = .true.
-                                exit
+                                exit outer2
                             endif
                         enddo
-                        if (bool_sublim) exit
-                    enddo
+                    enddo outer2
                 endif
-                if ((co2_ice(ig,islope) < 1.e-10) .and. (h2o_ice(ig,islope) > frost_albedo_threshold)) then
+                if (h2o_ice(ig,islope) > frost_albedo_threshold) then
                     albedo(ig,1,islope) = albedo_h2o_frost
                     albedo(ig,2,islope) = albedo_h2o_frost
@@ -881,22 +848,7 @@
                     emis(ig,islope) = emissiv
                 endif
-            else if ((co2_ice(ig,islope) > 1.e-3) .and. (d_co2ice(ig,islope) > 1.e-10)) then ! Put tsurf as tcond co2
-                ave = 0.
-                do t = 1,timelen
-                    ave = ave + beta_clap_co2/(alpha_clap_co2 - log(vmr_co2_PEM_phys(ig,t)*ps_timeseries(ig,t)/100.))
-                enddo
-                tsurf_avg(ig,islope) = ave/timelen
+            else if (co2_ice(ig,islope) > 1.e-10 .and. d_co2ice(ig,islope) > 1.e-10) then ! Put tsurf as tcond CO2
+                call computeTcondCO2(timelen,ngrid,nslope,vmr_co2_PEM_phys,ps_timeseries,ps_avg_global_ini,ps_avg_global_new,tsurf_avg)
             endif
-            !!!!!!!!!!!!!!!!!!!!!!!!!!!!!! SUBLIMATION??? !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-        enddo
-    enddo
-
-    do t = 1,timelen
-        tsurf_PCM_timeseries(:,:,t) = tsurf_PCM_timeseries(:,:,t) + tsurf_avg - Tsurfavg_before_saved
-    enddo
-    ! for the start
-    do ig = 1,ngrid
-        do islope = 1,nslope
-            tsurf(ig,islope) =  tsurf(ig,islope) - (Tsurfavg_before_saved(ig,islope) - tsurf_avg(ig,islope))
         enddo
     enddo
@@ -908,15 +860,17 @@
 ! II_d.3 Update soil temperature
         write(*,*)"Updating soil temperature"
-        allocate(Tsoil_locslope(ngrid,nsoilmx_PEM))
+        allocate(tsoil_avg_old(ngrid,nsoilmx_PEM))
         do islope = 1,nslope
+            tsoil_avg_old = tsoil_PEM(:,:,islope)
             call compute_tsoil_pem(ngrid,nsoilmx_PEM,.true.,TI_PEM(:,:,islope),timestep,tsurf_avg(:,islope),tsoil_PEM(:,:,islope))
             call compute_tsoil_pem(ngrid,nsoilmx_PEM,.false.,TI_PEM(:,:,islope),timestep,tsurf_avg(:,islope),tsoil_PEM(:,:,islope))
 
             do t = 1,timelen
-                Tsoil_locslope(:,1:nsoilmx) = tsoil_PEM(:,1:nsoilmx,islope) + tsoil_anom(:,:,islope,t)
-                Tsoil_locslope(:,nsoilmx + 1:) = tsoil_PEM(:,nsoilmx + 1:,islope)
                 do ig = 1,ngrid
                     do isoil = 1,nsoilmx_PEM
-                        watersoil_density_PEM_timeseries(ig,isoil,islope,t) = exp(beta_clap_h2o/Tsoil_locslope(ig,isoil) + alpha_clap_h2o)/Tsoil_locslope(ig,isoil)*mmol(igcm_h2o_vap)/(mugaz*r)
+            ! Update of soil temperature timeseries which is needed to compute the water soil density timeseries
+            tsoil_PEM_timeseries(ig,isoil,islope,t) = tsoil_PEM_timeseries(ig,isoil,islope,t)*tsoil_PEM(ig,isoil,islope)/tsoil_avg_old(ig,isoil)
+            ! Update of watersoil density
+                        watersoil_density_PEM_timeseries(ig,isoil,islope,t) = exp(beta_clap_h2o/tsoil_PEM_timeseries(ig,isoil,islope,t) + alpha_clap_h2o)/tsoil_PEM_timeseries(ig,isoil,islope,t)*mmol(igcm_h2o_vap)/(mugaz*r)
                         if (isnan(tsoil_PEM(ig,isoil,islope))) call abort_pem("PEM - Update Tsoil","NaN detected in tsoil_PEM",1)
                     enddo
@@ -925,8 +879,6 @@
         enddo
         watersoil_density_PEM_avg = sum(watersoil_density_PEM_timeseries,4)/timelen
-
+        deallocate(tsoil_avg_old)
         write(*,*) "Update of soil temperature done"
-
-        deallocate(Tsoil_locslope)
 
 ! II_d.4 Update the ice table
@@ -942,5 +894,5 @@
             do ig = 1,ngrid
                 do islope = 1,nslope
-                    call dyn_ss_ice_m(icetable_depth(ig,islope),tsurf_avg(ig,islope),tsoil_PEM(ig,:,islope),nsoilmx_PEM,TI_PEM(ig,1,nslope),ps(ig),(/sum(q_h2o_PEM_phys(ig,:))/size(q_h2o_PEM_phys,2)/),ice_porefilling(ig,:,islope),porefill,ssi_depth)
+                    call dyn_ss_ice_m(icetable_depth(ig,islope),tsurf_avg(ig,islope),tsoil_PEM(ig,:,islope),nsoilmx_PEM,TI_PEM(ig,1,nslope),ps_avg(ig),(/sum(q_h2o_PEM_phys(ig,:))/size(q_h2o_PEM_phys,2)/),ice_porefilling(ig,:,islope),porefill,ssi_depth)
                     icetable_depth(ig,islope) = ssi_depth
                     ice_porefilling(ig,:,islope) = porefill
@@ -952,10 +904,10 @@
 
 ! II_d.5 Update the soil thermal properties
-        call update_soil_thermalproperties(ngrid,nslope,nsoilmx_PEM,d_h2oice,h2o_ice,global_avg_press_new,icetable_depth,icetable_thickness,ice_porefilling,icetable_equilibrium,icetable_dynamic,TI_PEM)
+        call update_soil_thermalproperties(ngrid,nslope,nsoilmx_PEM,d_h2oice,h2o_ice,ps_avg_global_new,icetable_depth,icetable_thickness,ice_porefilling,icetable_equilibrium,icetable_dynamic,TI_PEM)
 
 ! II_d.6 Update the mass of the regolith adsorbed
         if (adsorption_pem) then
-            call regolith_adsorption(ngrid,nslope,nsoilmx_PEM,timelen,d_h2oice,d_co2ice,                           &
-                                     h2o_ice,co2_ice,tsoil_PEM,TI_PEM,ps_timeseries,q_co2_PEM_phys,q_h2o_PEM_phys, &
+            call regolith_adsorption(ngrid,nslope,nsoilmx_PEM,timelen,d_h2oice,d_co2ice,h2o_ice,co2_ice, &
+                                     tsoil_PEM,TI_PEM,ps_timeseries,q_co2_PEM_phys,q_h2o_PEM_phys,       &
                                      h2o_adsorbed_phys,delta_h2o_adsorbed,co2_adsorbed_phys,delta_co2_adsorbed)
 
@@ -988,5 +940,5 @@
 !    II_e Outputs
 !------------------------
-    call writediagpem(ngrid,'ps_avg','Global average pressure','Pa',0,(/global_avg_press_new/))
+    call writediagpem(ngrid,'ps_avg','Global average pressure','Pa',0,(/ps_avg_global_new/))
     do islope = 1,nslope
         write(str2(1:2),'(i2.2)') islope
@@ -996,5 +948,5 @@
         call writediagpem(ngrid,'d_co2ice_slope'//str2,'CO2 ice tend','kg.m-2.year-1',2,d_co2ice(:,islope))
         call writediagpem(ngrid,'Flow_co2ice_slope'//str2,'CO2 ice flow','Boolean',2,flag_co2flow(:,islope))
-        call writediagpem(ngrid,'tsurf_slope'//str2,'tsurf','K',2,tsurf(:,islope))
+        call writediagpem(ngrid,'tsurf_slope'//str2,'tsurf','K',2,tsurf_avg(:,islope))
         if (icetable_equilibrium) then
             call writediagpem(ngrid,'ssi_depth_slope'//str2,'ice table depth','m',2,icetable_depth(:,islope))
@@ -1005,6 +957,6 @@
 
         if (soil_pem) then
-            call writediagsoilpem(ngrid,'tsoil_PEM_slope'//str2,'tsoil_PEM','K',3,tsoil_PEM(:,:,islope))
-            call writediagsoilpem(ngrid,'inertiesoil_PEM_slope'//str2,'TI_PEM','K',3,TI_PEM(:,:,islope))
+            call writediagsoilpem(ngrid,'tsoil_PEM_slope'//str2,'tsoil','K',3,tsoil_PEM(:,:,islope))
+            call writediagsoilpem(ngrid,'inertiesoil_PEM_slope'//str2,'TI','K',3,TI_PEM(:,:,islope))
             if (icetable_dynamic) call writediagsoilpem(ngrid,'ice_porefilling'//str2,'ice pore filling','-',3,ice_porefilling(:,:,islope))
             if (adsorption_pem) then
@@ -1019,5 +971,5 @@
 !    II_f Update the tendencies
 !------------------------
-    call recomp_tend_co2(ngrid,nslope,timelen,d_co2ice,d_co2ice_ini,co2_ice,emis,vmr_co2_PCM,vmr_co2_PEM_phys,ps_timeseries,global_avg_press_PCM,global_avg_press_new)
+    call recomp_tend_co2(ngrid,nslope,timelen,d_co2ice,d_co2ice_ini,co2_ice,emis,vmr_co2_PCM,vmr_co2_PEM_phys,ps_timeseries,ps_avg_global_old,ps_avg_global_new)
 
 !------------------------
@@ -1026,6 +978,6 @@
 !------------------------
     write(*,*) "Checking the stopping criteria..."
-    call stopping_crit_h2o_ice(cell_area,h2oice_ini_surf,ini_h2oice_sublim,h2o_ice,stopPEM,ngrid)
-    call stopping_crit_co2(cell_area,co2ice_ini_surf,ini_co2ice_sublim,co2_ice,stopPEM,ngrid,global_avg_press_PCM,global_avg_press_new,nslope)
+    call stopping_crit_h2o_ice(cell_area,h2oice_ini_surf,is_h2oice_sublim_ini,h2o_ice,stopPEM,ngrid)
+    call stopping_crit_co2(cell_area,co2ice_sublim_surf_ini,is_co2ice_sublim_ini,co2_ice,stopPEM,ngrid,ps_avg_global_ini,ps_avg_global_new,nslope)
     i_myear_leg = i_myear_leg + dt
     i_myear = i_myear + dt
@@ -1061,7 +1013,4 @@
         write(*,*) "Number of simulated Martian years: i_myear =", i_myear
     endif
-
-    global_avg_press_old = global_avg_press_new
-
 enddo ! big time iteration loop of the pem
 !------------------------------ END RUN --------------------------------
@@ -1072,5 +1021,5 @@
 !    III_a Update surface value for the PCM start files
 !------------------------
-! III_a.1 Ice update (for startfi)
+! III_a.1 Ice update for start file
 watercap = 0.
 perennial_co2ice = co2_ice
@@ -1100,23 +1049,28 @@
 enddo
 
-! III_a.2 Tsoil update (for startfi)
+! III.a.2. Tsurf update for start file
+tsurf = tsurf_avg + tsurf_dev
+
+! III_a.3 Tsoil update for start file
 if (soil_pem) then
     inertiesoil = TI_PEM(:,:nsoilmx,:)
-    tsoil = tsoil_PEM(:,1:nsoilmx,:) + tsoil_anom(:,:,:,timelen)
+    ! Tsurf has evolved and so the soil temperature profile needs to be adapted to match this new value
+    do isoil = 1,nsoilmx
+        tsoil_dev(:,isoil,:) = tsoil_dev(:,isoil,:)*(tsurf_avg(:,:) - tsoil_PEM(:,1,:))/tsoil_dev(:,1,:)
+    enddo
+    tsoil = tsoil_PEM(:,1:nsoilmx,:) + tsoil_dev
 #ifndef CPP_STD
     flux_geo = fluxgeo
 #endif
 endif
-deallocate(tsoil_anom)
-
-! III_a.4 Pressure (for start)
-ps = ps*global_avg_press_new/global_avg_press_PCM
-ps_start_PCM = ps_start_PCM*global_avg_press_new/global_avg_press_PCM
-
-! III_a.5 Tracer (for start)
-allocate(zplev_new(ngrid,nlayer + 1))
-
+
+! III_a.4 Pressure update for start file
+ps_start = ps_avg + ps_dev
+
+! III_a.5 Tracers update for start file
+allocate(zplev_start0(ngrid,nlayer + 1),zplev_new(ngrid,nlayer + 1))
 do l = 1,nlayer + 1
-    zplev_new(:,l) = ap(l) + bp(l)*ps_start_PCM
+    zplev_start0(:,l) = ap(l) + bp(l)*ps_start0
+    zplev_new(:,l) = ap(l) + bp(l)*ps_start
 enddo
 
@@ -1125,5 +1079,5 @@
         do l = 1,llm - 1
             do ig = 1,ngrid
-                q(ig,l,nnq) = q(ig,l,nnq)*(zplev_PCM(ig,l) - zplev_PCM(ig,l + 1))/(zplev_new(ig,l) - zplev_new(ig,l + 1))
+                q(ig,l,nnq) = q(ig,l,nnq)*(zplev_start0(ig,l) - zplev_start0(ig,l + 1))/(zplev_new(ig,l) - zplev_new(ig,l + 1))
             enddo
             q(:,llm,nnq) = q(:,llm - 1,nnq)
@@ -1132,6 +1086,6 @@
         do l = 1,llm - 1
             do ig = 1,ngrid
-                q(ig,l,nnq) = q(ig,l,nnq)*(zplev_PCM(ig,l) - zplev_PCM(ig,l + 1))/(zplev_new(ig,l) - zplev_new(ig,l + 1)) &
-                              + ((zplev_new(ig,l) - zplev_new(ig,l + 1)) - (zplev_PCM(ig,l) - zplev_PCM(ig,l + 1)))/(zplev_new(ig,l) - zplev_new(ig,l + 1))
+                q(ig,l,nnq) = q(ig,l,nnq)*(zplev_start0(ig,l) - zplev_start0(ig,l + 1))/(zplev_new(ig,l) - zplev_new(ig,l + 1)) &
+                              + ((zplev_new(ig,l) - zplev_new(ig,l + 1)) - (zplev_start0(ig,l) - zplev_start0(ig,l + 1)))/(zplev_new(ig,l) - zplev_new(ig,l + 1))
             enddo
             q(:,llm,nnq) = q(:,llm - 1,nnq)
@@ -1140,5 +1094,5 @@
 enddo
 
-! Conserving the tracers mass for PCM start files
+! Conserving the tracers mass for start file
 do nnq = 1,nqtot
     do ig = 1,ngrid
@@ -1154,4 +1108,5 @@
     enddo
 enddo
+deallocate(zplev_start0,zplev_new)
 
 if (evol_orbit_pem) call recomp_orb_param(i_myear,i_myear_leg)
@@ -1171,16 +1126,16 @@
     do l = 1,nlayer
         do i = 1,ip1jmp1
-            teta(i,l)= teta(i,l)*(ps0(i)/ps(i))**kappa
+            teta(i,l)= teta(i,l)*(ps_start0(i)/ps_start(i))**kappa
         enddo
     enddo
     ! Correction on atmospheric pressure
-    call pression(ip1jmp1,ap,bp,ps,p)
+    call pression(ip1jmp1,ap,bp,ps_start,p)
     ! Correction on the mass of atmosphere
     call massdair(p,masse)
     call dynredem0("restart.nc",day_ini,phis)
-    call dynredem1("restart.nc",time_0,vcov,ucov,teta,q,masse,ps)
+    call dynredem1("restart.nc",time_0,vcov,ucov,teta,q,masse,ps_start)
     write(*,*) "restart.nc has been written"
 #else
-    call writerestart1D('restart1D.txt',ps(1),tsurf(1,:),nlayer,size(tsurf,2),teta,ucov,vcov,nq,noms,qsurf(1,:,:),q)
+    call writerestart1D('restart1D.txt',ps_start(1),tsurf(1,:),nlayer,size(tsurf,2),teta,ucov,vcov,nq,noms,qsurf(1,:,:),q)
     write(*,*) "restart1D.txt has been written"
 #endif
@@ -1231,10 +1186,12 @@
     deallocate(new_str,new_lag1,new_lag2,current1,current2)
 endif
-deallocate(vmr_co2_PCM,ps_timeseries,tsurf_PCM_timeseries,q_co2_PEM_phys,q_h2o_PEM_phys)
-deallocate(watersurf_density_avg,watersoil_density_timeseries,Tsurfavg_before_saved)
-deallocate(tsoil_phys_PEM_timeseries,watersoil_density_PEM_timeseries,watersoil_density_PEM_avg)
-deallocate(delta_co2_adsorbed,delta_h2o_adsorbed,vmr_co2_PEM_phys,delta_h2o_icetablesublim)
+deallocate(ps_start,ps_start0,ps_timeseries,ps_avg,ps_dev)
+deallocate(tsurf_avg,tsurf_dev,tsurf_avg_old)
+deallocate(tsoil_PEM,tsoil_dev,tsoil_PEM_timeseries)
+deallocate(vmr_co2_PCM,vmr_co2_PEM_phys,q_co2_PEM_phys,q_h2o_PEM_phys)
+deallocate(watersurf_density_avg,watersoil_density_PEM_timeseries,watersoil_density_PEM_avg)
+deallocate(delta_co2_adsorbed,delta_h2o_adsorbed,delta_h2o_icetablesublim)
 deallocate(icetable_thickness_old,ice_porefilling_old,zshift_surf,zlag)
-deallocate(is_co2ice_ini,co2ice_disappeared,ini_co2ice_sublim,ini_h2oice_sublim,stratif)
+deallocate(is_co2ice_ini,co2ice_disappeared,is_co2ice_sublim_ini,is_h2oice_sublim_ini,stratif)
 !----------------------------- END OUTPUT ------------------------------
 
